Index: chan_sip.c
===================================================================
--- chan_sip.c	(revision 103307)
+++ chan_sip.c	(working copy)
@@ -3654,7 +3654,9 @@
 	struct sip_peer *p = (struct sip_peer *) name;
 	return 	!(!inaddrcmp(&p->addr, sin) || 
 					(ast_test_flag(&p->flags[0], SIP_INSECURE_PORT) &&
-					(p->addr.sin_addr.s_addr == sin->sin_addr.s_addr)));
+					(p->addr.sin_addr.s_addr == sin->sin_addr.s_addr)) ||
+					(ast_test_flag(&p->flags[0], SIP_INSECURE_INVITE) && 
+					 p->ha && ast_apply_ha(p->ha, sin)));
 }
 
 /*! \brief Locate peer by name or ip address 
